import { Component } from 'react';
import type { ImageSourcePropType } from 'react-native';
import type { SvgProps } from './elements/Svg';
export declare function getUriFromSource(source: ImageSourcePropType): string;
export declare function loadLocalRawResourceDefault(source: ImageSourcePropType): Promise<string>;
export declare function isUriAnAndroidResourceIdentifier(uri?: string): boolean;
export declare function loadAndroidRawResource(uri: string): Promise<string | null>;
export declare function loadLocalRawResourceAndroid(source: ImageSourcePropType): Promise<string | null>;
export declare const loadLocalRawResource: typeof loadLocalRawResourceAndroid;
export type LocalProps = SvgProps & {
    asset: ImageSourcePropType;
    override?: Object;
};
export type LocalState = {
    xml: string | null;
};
export declare function LocalSvg(props: LocalProps): JSX.Element;
export declare class WithLocalSvg extends Component<LocalProps, LocalState> {
    state: {
        xml: null;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: {
        asset: ImageSourcePropType;
    }): void;
    load(asset: ImageSourcePropType): Promise<void>;
    render(): JSX.Element;
}
export default LocalSvg;
//# sourceMappingURL=LocalSvg.d.ts.map